Loading...
Searching...
No Matches
Crement Struct Reference

A Crement node represents a single increment '++' and decrement '–' operation. As well as it's crement type, it also stores whether the semantics constructed a post or pre-crement i.e. ++a or a++. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for Crement:

## Public Types

enum | Operation { Increment , Decrement }
| A simple enum representing the crement type. More...
using | UniquePtr = std::unique_ptr<Crement>

enum

NodeType {
TreeNode , StatementListNode , BlockNode , ConditionalStatementNode ,
CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode ,
CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode ,
CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode ,
DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode ,
ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node ,
ValueFloatNode , ValueDoubleNode , ValueStrNode
}

| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions

| Crement (Expression *expr, const Operation op, bool post)
| Construct a new Crement with a valid expression, transferring ownership of the expression to the Crement node and updating parent data on the expression.
| Crement (const Crement &other)
| Deep copy constructor for a Crement, performing a deep copy on the underlying expressions, ensuring parent information is updated.
| ~Crement () override=default
Crement * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Expression * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
size_t | children () const override final
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Expression * | child (const size_t i) const override final
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
bool | replacechild (const size_t i, Node *node) override final
| Virtual method that attempted to replace a child at a given index with a provided node type.
Operation | operation () const
| Query the type of the Crement operation. This does not hold post or pre-crement information.
bool | increment () const
| Query if this Crement node represents an incrementation ++.
bool | decrement () const
| Query if this Crement node represents an decrement –.
bool | pre () const
| Query if this Crement node represents a pre crement ++a.
bool | post () const
| Query if this Crement node represents a post crement a++.
const Expression * | expression () const
| Access a const pointer to the expression being crements as an abstract Expression.
Name/Type
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Detailed Description

A Crement node represents a single increment '++' and decrement '–' operation. As well as it's crement type, it also stores whether the semantics constructed a post or pre-crement i.e. ++a or a++.

## Member Typedef Documentation

## Ptr

using Ptr = std::shared_ptr<Node>

inherited

## UniquePtr

using UniquePtr = std::unique_ptr<Crement>

## Member Enumeration Documentation

## NodeType

enum NodeType

inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Operation

enum Operation

A simple enum representing the crement type.

Enumerator
Increment |
Decrement |

## Constructor & Destructor Documentation

## Crement() [1/2]

Crement | ( | Expression * | expr,
|  | const Operation | op,
|  | bool | post )

inline

Construct a new Crement with a valid expression, transferring ownership of the expression to the Crement node and updating parent data on the expression.

Parameters

  expr | The expression to crement
  op | The type of crement operation; Increment or Decrement
  post | True if the crement operation is a post crement i.e. a++, false if the operation is a pre crement i.e. ++a

## Crement() [2/2]

Crement | ( | const Crement & | other | ) |

inline

Deep copy constructor for a Crement, performing a deep copy on the underlying expressions, ensuring parent information is updated.

Parameters

  other | A const reference to another Crement to deep copy

## ~Crement()

~Crement | ( |  | ) |

override default

## Member Function Documentation

## basetype()

const Expression * basetype | ( |  | ) | const

inline override virtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Node.

## child()

const Expression * child | ( | const size_t | i | ) | const

inline final override virtual

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Implements Node.

## childidx()

int64_t childidx | ( |  | ) | const

inline inherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).

Returns
  The child index of this node

## children()

size_t children | ( |  | ) | const

inline final override virtual

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Implements Node.

## copy()

Crement * copy | ( |  | ) | const

inline final override virtual

The deep copy method for a Node.

Implements Expression.

## decrement()

bool decrement | ( |  | ) | const

inline

Query if this Crement node represents an decrement –.

Returns
  True if this node is performing an decrement

## expression()

const Expression * expression | ( |  | ) | const

inline

Access a const pointer to the expression being crements as an abstract Expression.

Returns
  A const pointer to the expression

## increment()

bool increment | ( |  | ) | const

inline

Query if this Crement node represents an incrementation ++.

Returns
  True if this node is performing an increment

## isType()

template<typename NodeT>

bool isType | ( |  | ) | const

inline inherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## nodename()

const char * nodename | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.

## nodetype()

NodeType nodetype | ( |  | ) | const

inline override virtual

Virtual method for accessing node type information.

Implements Node.

## operation()

Operation operation | ( |  | ) | const

inline

Query the type of the Crement operation. This does not hold post or pre-crement information.

Returns
  The Crement operation being performed. This is either an Crement::Increment or Crement::Decrement.

## parent()

const Node * parent | ( |  | ) | const

inline inherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## post()

bool post | ( |  | ) | const

inline

Query if this Crement node represents a post crement a++.

Returns
  True if this node is performing a post crement

## pre()

bool pre | ( |  | ) | const

inline

Query if this Crement node represents a pre crement ++a.

Returns
  True if this node is performing a pre crement

## replace()

bool replace | ( | Node * | node | ) |

inline inherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## replacechild()

bool replacechild | ( | const size_t | i,
|  | Node * | node )

inline final override virtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Reimplemented from Node.

## setParent()

void setParent | ( | Node * | parent | ) |

inline inherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## subname()

const char * subname | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.